#!/usr/bin/env node

var _ = require("lodash");
var pkg = require('../package.json');
var program = require('commander');
var color = require('bash-color');

var publisher = require('../lib/gitbook2_publisher');

(function(){
    var str = pkg.name + " " + pkg.version;
    var author = "(^.^)y-~~ create by ulyn";
    var maxLen = author.length;
    if(maxLen < str){
        maxLen = str.length;
    }
    var sb = "";
    var blankNum = 1,hNum = 3;
    sb += createDupStr("-",hNum + blankNum + maxLen + hNum + blankNum) + "\n";
    sb += createDupStr("-",hNum) + createDupStr(" ",blankNum)
        + createDupStr("-",maxLen)
        + createDupStr(" ",blankNum) + createDupStr("-",hNum) + "\n";
    sb += createDupStr("-",hNum) + createDupStr(" ",blankNum + maxLen - str.length)
        + str
        + createDupStr(" ",blankNum + maxLen - str.length) + createDupStr("-",hNum) + "\n";
    sb += createDupStr("-",hNum) + createDupStr(" ",blankNum)
        + createDupStr(" ",maxLen)
        + createDupStr(" ",blankNum) + createDupStr("-",hNum) + "\n";
    sb += createDupStr("-",hNum) + createDupStr(" ",blankNum + maxLen - author.length)
        + author
        + createDupStr(" ",blankNum + maxLen - author.length) + createDupStr("-",hNum) + "\n";
    sb += createDupStr("-",hNum) + createDupStr(" ",blankNum)
        + createDupStr("-",maxLen)
        + createDupStr(" ",blankNum) + createDupStr("-",hNum) + "\n";
    sb += createDupStr("-",hNum + blankNum + maxLen + hNum + blankNum) + "\n";
    console.log(color.green(sb));
}());
function createDupStr(str,len){
    var result = "";
    for(var i=0;i<len;i++){
        result = result + str;
    }
    return result;
}

program
    .version(pkg.version)
//    .usage('[options] [value ...]')
//    .option('-p, --path', '文档文件夹目录路径')
    ;

program.command('*')
    .description('发布文档路径')
    .action(function(commandName){
        publisher.publish(commandName);
    });
var commander = program.parse(process.argv);
if(_.isEmpty(commander.args)) {
    publisher.publish(process.cwd());
}
