var _ = require("lodash");
var http = require('http');
var fs = require('fs');
var request = require('superagent');

function uploadFile(uploadUrl,params,fileParams,ondata,onerror){
   // console.log("upload %s %s",JSON.stringify(params),JSON.stringify(fileParams));
    var req = request.post(uploadUrl);
    _.forEach(params,function(val,key){
        req.field(key, val);
    });
    _.forEach(fileParams,function(val,key){
        req.attach(key,val);
    });
    req.end(function(err, res){
            if (res.ok) {
                req.request().end();
                ondata(res.text);
            } else {
                onerror && onerror(err, res);
            }
        });
}

function doPost(url,params,ondata,onerror){
    var req = request.post(url);
    _.forEach(params,function(val,key){
        req.field(key, val);
    });
    req.end(function(err, res){
        if (res.ok) {
            req.request().end();
            ondata(res.text);
        } else {
            onerror && onerror(err, res);
        }
    });
}

module.exports = {
    uploadFile:uploadFile,
    doPost:doPost
};